/*
 * $Id$
 */

package org.apache.maven.plugin.nbm.model;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.*;
import java.util.List;

/**
 * Class NbmResource.
 * 
 * @version $Revision$ $Date$
 */
public class NbmResource implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field baseDirectory
     */
    private String baseDirectory;

    /**
     * Field relativeClusterPath
     */
    private String relativeClusterPath;

    /**
     * Field includes
     */
    private java.util.List includes;

    /**
     * Field excludes
     */
    private java.util.List excludes;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addExclude
     * 
     * @param string
     */
    public void addExclude(String string)
    {
        getExcludes().add( string );
    } //-- void addExclude(String) 

    /**
     * Method addInclude
     * 
     * @param string
     */
    public void addInclude(String string)
    {
        getIncludes().add( string );
    } //-- void addInclude(String) 

    /**
     * Method getBaseDirectory
     */
    public String getBaseDirectory()
    {
        return this.baseDirectory;
    } //-- String getBaseDirectory() 

    /**
     * Method getExcludes
     */
    public java.util.List getExcludes()
    {
        if ( this.excludes == null )
        {
            this.excludes = new java.util.ArrayList();
        }
        
        return this.excludes;
    } //-- java.util.List getExcludes() 

    /**
     * Method getIncludes
     */
    public java.util.List getIncludes()
    {
        if ( this.includes == null )
        {
            this.includes = new java.util.ArrayList();
        }
        
        return this.includes;
    } //-- java.util.List getIncludes() 

    /**
     * Method getRelativeClusterPath
     */
    public String getRelativeClusterPath()
    {
        return this.relativeClusterPath;
    } //-- String getRelativeClusterPath() 

    /**
     * Method removeExclude
     * 
     * @param string
     */
    public void removeExclude(String string)
    {
        getExcludes().remove( string );
    } //-- void removeExclude(String) 

    /**
     * Method removeInclude
     * 
     * @param string
     */
    public void removeInclude(String string)
    {
        getIncludes().remove( string );
    } //-- void removeInclude(String) 

    /**
     * Method setBaseDirectory
     * 
     * @param baseDirectory
     */
    public void setBaseDirectory(String baseDirectory)
    {
        this.baseDirectory = baseDirectory;
    } //-- void setBaseDirectory(String) 

    /**
     * Method setExcludes
     * 
     * @param excludes
     */
    public void setExcludes(java.util.List excludes)
    {
        this.excludes = excludes;
    } //-- void setExcludes(java.util.List) 

    /**
     * Method setIncludes
     * 
     * @param includes
     */
    public void setIncludes(java.util.List includes)
    {
        this.includes = includes;
    } //-- void setIncludes(java.util.List) 

    /**
     * Method setRelativeClusterPath
     * 
     * @param relativeClusterPath
     */
    public void setRelativeClusterPath(String relativeClusterPath)
    {
        this.relativeClusterPath = relativeClusterPath;
    } //-- void setRelativeClusterPath(String) 

}
