/*
 * $Id$
 */

package org.apache.maven.plugin.nbm.model;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.*;
import java.util.List;

/**
 * Class NetbeansModule.
 * 
 * @version $Revision$ $Date$
 */
public class NetbeansModule implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field moduleType
     */
    private String moduleType = "normal";

    /**
     * Field codeNameBase
     */
    private String codeNameBase;

    /**
     * Field cluster
     */
    private String cluster = "maven1";

    /**
     * Field requiresRestart
     */
    private boolean requiresRestart = false;

    /**
     * Field manifest
     */
    private String manifest = "src/main/nbm/manifest.mf";

    /**
     * Field homepageUrl
     */
    private String homepageUrl;

    /**
     * Field distributionUrl
     */
    private String distributionUrl;

    /**
     * Field author
     */
    private String author;

    /**
     * Field licenseName
     */
    private String licenseName;

    /**
     * Field licenseFile
     */
    private String licenseFile;

    /**
     * Field libraries
     */
    private java.util.List libraries;

    /**
     * Field dependencies
     */
    private java.util.List dependencies;

    /**
     * Field nbmResources
     */
    private java.util.List nbmResources;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addDependency
     * 
     * @param dependency
     */
    public void addDependency(Dependency dependency)
    {
        getDependencies().add( dependency );
    } //-- void addDependency(Dependency) 

    /**
     * Method addLibrary
     * 
     * @param string
     */
    public void addLibrary(String string)
    {
        getLibraries().add( string );
    } //-- void addLibrary(String) 

    /**
     * Method addNbmResource
     * 
     * @param nbmResource
     */
    public void addNbmResource(NbmResource nbmResource)
    {
        getNbmResources().add( nbmResource );
    } //-- void addNbmResource(NbmResource) 

    /**
     * Method getAuthor
     */
    public String getAuthor()
    {
        return this.author;
    } //-- String getAuthor() 

    /**
     * Method getCluster
     */
    public String getCluster()
    {
        return this.cluster;
    } //-- String getCluster() 

    /**
     * Method getCodeNameBase
     */
    public String getCodeNameBase()
    {
        return this.codeNameBase;
    } //-- String getCodeNameBase() 

    /**
     * Method getDependencies
     */
    public java.util.List getDependencies()
    {
        if ( this.dependencies == null )
        {
            this.dependencies = new java.util.ArrayList();
        }
        
        return this.dependencies;
    } //-- java.util.List getDependencies() 

    /**
     * Method getDistributionUrl
     */
    public String getDistributionUrl()
    {
        return this.distributionUrl;
    } //-- String getDistributionUrl() 

    /**
     * Method getHomepageUrl
     */
    public String getHomepageUrl()
    {
        return this.homepageUrl;
    } //-- String getHomepageUrl() 

    /**
     * Method getLibraries
     */
    public java.util.List getLibraries()
    {
        if ( this.libraries == null )
        {
            this.libraries = new java.util.ArrayList();
        }
        
        return this.libraries;
    } //-- java.util.List getLibraries() 

    /**
     * Method getLicenseFile
     */
    public String getLicenseFile()
    {
        return this.licenseFile;
    } //-- String getLicenseFile() 

    /**
     * Method getLicenseName
     */
    public String getLicenseName()
    {
        return this.licenseName;
    } //-- String getLicenseName() 

    /**
     * Method getManifest
     */
    public String getManifest()
    {
        return this.manifest;
    } //-- String getManifest() 

    /**
     * Method getModuleType
     */
    public String getModuleType()
    {
        return this.moduleType;
    } //-- String getModuleType() 

    /**
     * Method getNbmResources
     */
    public java.util.List getNbmResources()
    {
        if ( this.nbmResources == null )
        {
            this.nbmResources = new java.util.ArrayList();
        }
        
        return this.nbmResources;
    } //-- java.util.List getNbmResources() 

    /**
     * Method isRequiresRestart
     */
    public boolean isRequiresRestart()
    {
        return this.requiresRestart;
    } //-- boolean isRequiresRestart() 

    /**
     * Method removeDependency
     * 
     * @param dependency
     */
    public void removeDependency(Dependency dependency)
    {
        getDependencies().remove( dependency );
    } //-- void removeDependency(Dependency) 

    /**
     * Method removeLibrary
     * 
     * @param string
     */
    public void removeLibrary(String string)
    {
        getLibraries().remove( string );
    } //-- void removeLibrary(String) 

    /**
     * Method removeNbmResource
     * 
     * @param nbmResource
     */
    public void removeNbmResource(NbmResource nbmResource)
    {
        getNbmResources().remove( nbmResource );
    } //-- void removeNbmResource(NbmResource) 

    /**
     * Method setAuthor
     * 
     * @param author
     */
    public void setAuthor(String author)
    {
        this.author = author;
    } //-- void setAuthor(String) 

    /**
     * Method setCluster
     * 
     * @param cluster
     */
    public void setCluster(String cluster)
    {
        this.cluster = cluster;
    } //-- void setCluster(String) 

    /**
     * Method setCodeNameBase
     * 
     * @param codeNameBase
     */
    public void setCodeNameBase(String codeNameBase)
    {
        this.codeNameBase = codeNameBase;
    } //-- void setCodeNameBase(String) 

    /**
     * Method setDependencies
     * 
     * @param dependencies
     */
    public void setDependencies(java.util.List dependencies)
    {
        this.dependencies = dependencies;
    } //-- void setDependencies(java.util.List) 

    /**
     * Method setDistributionUrl
     * 
     * @param distributionUrl
     */
    public void setDistributionUrl(String distributionUrl)
    {
        this.distributionUrl = distributionUrl;
    } //-- void setDistributionUrl(String) 

    /**
     * Method setHomepageUrl
     * 
     * @param homepageUrl
     */
    public void setHomepageUrl(String homepageUrl)
    {
        this.homepageUrl = homepageUrl;
    } //-- void setHomepageUrl(String) 

    /**
     * Method setLibraries
     * 
     * @param libraries
     */
    public void setLibraries(java.util.List libraries)
    {
        this.libraries = libraries;
    } //-- void setLibraries(java.util.List) 

    /**
     * Method setLicenseFile
     * 
     * @param licenseFile
     */
    public void setLicenseFile(String licenseFile)
    {
        this.licenseFile = licenseFile;
    } //-- void setLicenseFile(String) 

    /**
     * Method setLicenseName
     * 
     * @param licenseName
     */
    public void setLicenseName(String licenseName)
    {
        this.licenseName = licenseName;
    } //-- void setLicenseName(String) 

    /**
     * Method setManifest
     * 
     * @param manifest
     */
    public void setManifest(String manifest)
    {
        this.manifest = manifest;
    } //-- void setManifest(String) 

    /**
     * Method setModuleType
     * 
     * @param moduleType
     */
    public void setModuleType(String moduleType)
    {
        this.moduleType = moduleType;
    } //-- void setModuleType(String) 

    /**
     * Method setNbmResources
     * 
     * @param nbmResources
     */
    public void setNbmResources(java.util.List nbmResources)
    {
        this.nbmResources = nbmResources;
    } //-- void setNbmResources(java.util.List) 

    /**
     * Method setRequiresRestart
     * 
     * @param requiresRestart
     */
    public void setRequiresRestart(boolean requiresRestart)
    {
        this.requiresRestart = requiresRestart;
    } //-- void setRequiresRestart(boolean) 

}
